---
title: Client
slug: Web/API/Client
tags:
  - API
  - Client
  - Experimental
  - Interface
  - Reference
  - Service Workers
  - Service worker API
  - ServiceWorkerClient
  - ServiceWorkers
---
<p>{{APIRef("Service Workers API")}}</p>

<p><span class="seoSummary">The <code>Client</code> interface represents an executable context such as a {{domxref("Worker")}}, or a {{domxref("SharedWorker")}}. {{domxref("Window")}} clients are represented by the more-specific {{domxref("WindowClient")}}. You can get <code>Client</code>/<code>WindowClient</code> objects from methods such as {{domxref("Clients.matchAll","Clients.matchAll()")}} and {{domxref("Clients.get","Clients.get()")}}.</span></p>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("Client.postMessage()")}}</dt>
 <dd>Sends a message to the client.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("Client.id")}} {{readonlyInline}}</dt>
 <dd>The universally unique identifier of the client as a string.</dd>
 <dt>{{domxref("Client.type")}} {{readonlyInline}}</dt>
 <dd>The client's type as a string. It can be "<code>window"</code>, "<code>worker"</code>, or "<code>sharedworker"</code>.</dd>
 <dt>{{domxref("Client.url")}} {{readonlyInline}}</dt>
 <dd>The URL of the client as a string.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#client', 'Client')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Client")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">Promises</a></li>
</ul>
